<template>
    <div class="filter">
        <div class="filter-body">
            <div class="transport-type-filter">
                <transition name="fade">
                <div class="transport-types" v-if="showFilter">
                <ul>
                   <li class="transport-type">
                        <NuxtImg @click="toggleTransportTypeState('tram')" class="type-image" :src="getTransportTypeImage('tram')" width="20"></NuxtImg>
                        <div class="lines">
                            <div class="line" v-for="line in transportLines?.tram">
                                <li><div @click="toggleFromFilter('transportLines', line.line)" :class="{'line-number-off': !filterState.getBooleanState('transportLines',line.line)}" class="line-number line-number-type-tram">{{line.line}}</div></li>
                            </div>
                        </div>
                    </li> 
                    <li class="transport-type">
                    <NuxtImg @click="toggleTransportTypeState('trolley')" class="type-image" :src="getTransportTypeImage('trolley')" width="20"></NuxtImg>
                        <div class="lines">
                            <div v-for="line in transportLines?.trolley">
                                <li><div @click="toggleFromFilter('transportLines', line.line)" :class="{'line-number-off': !filterState.getBooleanState('transportLines',line.line)}" class="line-number line-number-type-trolley">{{line.line}}</div></li>
                            </div>
                        </div>
                    </li> 
                    <li class="transport-type">
                    <NuxtImg @click="toggleTransportTypeState('bus')" class="type-image" :src="getTransportTypeImage('bus')" width="20"></NuxtImg>
                        <div class="lines">
                            <div v-for="line in transportLines?.bus">
                                <li><div @click="toggleFromFilter('transportLines', line.line)" :class="{'line-number-off': !filterState.getBooleanState('transportLines',line.line)}" class="line-number line-number-type-bus">{{line.line}}</div></li>
                            </div>
                        </div>
                    </li>
                </ul>
            </div>
            </transition>
            <div @click="toggleShowFilter" class="hide-show-filter"><span v-if="showFilter">Skryť filter</span><span v-if="!showFilter">Zobraziť filter</span></div>
            </div>
        </div>
    </div>
</template>

<script>
import config from '~/config';
import _ from 'lodash';

export default {

    setup(){
        const filterState = useFilterState();
        const mapStore = useMapStore();
        return {filterState, mapStore}
    },
    data() {
        return {
            transportTypeImages: config.transportTypeFilter,
            transportLines: {},
            transportLineTimeout: null,
            transportTypeStates: {
                bus: true,
                tram: true,
                trolley: true
            },
            showFilter: false
        }
    },
    mounted() {
        var self = this;
        this.mapStore.fetchVehicles(function(){
            self.initTransportLines()
        });
    },
    watch: {
        transportLines() {
            clearTimeout(this.transportLineTimeout)
        }
    },
    methods: {
        initTransportLines() {
            const unique = _.uniqBy(this.mapStore.vehicles,"line").map(function(item){
                return {
                    line: item.line,
                    transportType: item.transportType
                }
            })
            const sorted = _.sortBy(unique, (item)=> parseInt(item.line))
            const lineNumbers = sorted.map(function(item){
                return item.line;
            })
            this.filterState.filter.transportLines = lineNumbers;
            const reducedLines = _.groupBy(sorted, 'transportType');
            this.transportLines = reducedLines;
            this.transportLineTimeout = setTimeout(this.initTransportLines, 1000)

        },
        toggleFromFilter(type, key) {
            console.log("key", key)
            if (typeof key == "object"){
                // for 
            }
            const state = this.filterState.getBooleanState(type, key);
            this.filterState.toggleFromFilter(type,key)
            this.$emit('filterChanged');
        },
        toggleTransportTypeState(type) {
            const newState = this.filterState.toggleTransportTypeState(type)
            const map = this.transportLines[type].map((item) => {
                    return item.line
                })
            if (newState === false) {
                this.filterState.filter.transportLines = this.filterState.filter.transportLines.filter((item) => {
                    return !map.includes(item)
                })
            } else {
                this.filterState.filter.transportLines = _.union(this.filterState.filter.transportLines, map)
            }
        },
        toggleState(type, key) {
            const current = this.filterState.getState(type, key);
            const newState = current === "on" ? "off" : "on";

            this.filterState.setState(type,key,newState);
            this.$emit('filterChanged');
        },
        getState(type, key) {
            return this.filterState.getState(type, key)
        },
        getTransportTypeImage(transportType) {
            const boolstate = this.filterState.filter.transportTypeStates[transportType]
            const state = boolstate ? "on" : "off"
            const image = _.get(this.transportTypeImages,transportType+"."+state);
            return image
        },
        toggleShowFilter(){
            this.showFilter = !this.showFilter;
        }
    }
}

</script>

<style lang="scss">
    .fade-enter-active, .fade-leave-active {
        transition: opacity 0.5s;
    }
    .fade-enter, .fade-leave-to {
        opacity: 0;
    }
    .filter {
        width: 100%;
        display: flex;
        justify-content: center;
    }
    .filter-body {
        z-index: 1000;
        position: absolute;
        background: #fff;
        width: 65%;
        margin: 0 auto; 
        // height: 10px;
        border-bottom-left-radius: 50px;
        border-bottom-right-radius: 50px;
    }


    .transport-type-filter {
        .transport-types {
            margin-top: 10px;
            margin-bottom: 10px;
        }
        ul {
            margin-top: 0;
        }
        li {
            display: flex;
            flex-direction: row;
        }
        .lines {
            display: flex;
            flex-wrap: wrap;
            padding-top:2px;
            & > div {
                margin-bottom: 4px;
            }
        }
        .line li {
            display: flex;
        }

        li.transport-type {
            margin-bottom: 5px;
            .type-image {
                display: flex;
                align-self: baseline;
                flex-shrink: 0;
                margin-right: 5px;
            }
        }

        

        .line-number{
            cursor: pointer;
            font-family: "Helvetica Neue", Arial, Helvetica, sans-serif;
            width: 28px;
            height: 28px;
            border-radius: 50% 50%;
            color: #fff;
            font-weight: bold;
            display: flex;
            align-items: center;
            justify-content: center;
            margin-left: 2px;
            margin-right: 2px;
            font-size: 14px;
            &-type-tram {
                background: $bg-red;
            }
            &-type-trolley {
                background: $bg-orange;
            }
            &-type-bus {
                background: $bg-blue;
            }
        }

        .line-number-off{
            background: silver;
        }

        .hide-show-filter {
            text-align: center;
            margin-bottom: 10px;
            cursor: pointer;
        }
    }
</style>